# Problem

PROBLEM_SEQUENCE_LENGTH = 7

# Random

SEED = 42

# WTF

START_TOKEN = 0

# Common

# There are somehow 32 dimensions in some matrix
# aka vocabulary size = 64 bit integer / 32 / 100.000.000.000
#COMMON_EMBEDDINGS_COUNT = int((2 ** 63 - 1) / 32 / 100000000000)
COMMON_EMBEDDINGS_COUNT = 5000

# Rollout

ROLLOUT_GIVEN_NUM_STOP = 7

# Adversarial Training

# ADVERSARIAL_ROUNDS_COUNT = 200 * 4
ADVERSARIAL_ROUNDS_COUNT = 10 ** 10
GENERATOR_SAMPLE_COUNT = 10000

# LSTM Oracle

HIDDEN_DIMENSION = 32  # hidden state dimension of lstm cell and generator

BATCH_SIZE = 64

# Generator
# supervise (maximum likelihood estimation) epochs

#GENERATOR_PRETRAINING_EPOCH_COUNT = 120
GENERATOR_PRETRAINING_EPOCH_COUNT = 120

GENERATOR_EMBEDDINGS_DIMENSION = 32

# Discriminator

DISCRIMINATOR_CLASS_COUNT = 2
DISCRIMINATOR_EMBEDDING_DIMENSION = 64
DISCRIMINATOR_FILTER_SIZES = [1, 2, 3, 4, 5, 6, 7]
DISCRIMINATOR_FILTER_COUNTS = [100, 200, 300, 400, 300, 200, 100]
DISCRIMINATOR_DROPOUT_KEEPING_PROBABILITY = 0.75
DISCRIMINATOR_L2_REG_LAMBDA = 0.2  # Default: 0.0
DISCRIMINATOR_BATCH_SIZE = 64

DISCRIMINATOR_PRETRAINING_EPOCH_COUNT = 20
DISCRIMINATOR_PRETRAINING_BATCH_COUNT = 5

#DISCRIMINATOR_PRETRAINING_EPOCH_COUNT = 60
DISCRIMINATOR_TRAINING_ROUND_COUNT = 10
DISCRIMINATOR_TRAINING_EPOCH_COUNT = 5
